Bug 1005718 - Review Request: faience-icon-theme - Faience icon theme
Review Request: faience-icon-theme - Faience icon theme
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
Alec Leamas
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-09 05:19 EDT by Wolfgang Ulbrich
Modified: 2014-12-03 01:37 EST (History)
3 users (show)

See Also:
Fixed In Version: faience-icon-theme-0.5-3.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-12-03 01:37:03 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
leamas.alec: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Fix whitespace (1.07 KB, patch)
2013-09-11 02:06 EDT, Alec Leamas
no flags Details | Diff
remove ||: (670 bytes, patch)
2013-09-11 02:07 EDT, Alec Leamas
no flags Details | Diff
fix install options (712 bytes, patch)
2013-09-11 02:08 EDT, Alec Leamas
no flags Details | Diff
%install fixes: bad macro, bad options, cleanup (1009 bytes, patch)
2013-09-11 02:09 EDT, Alec Leamas
no flags Details | Diff
Formatting (995 bytes, patch)
2013-09-11 02:09 EDT, Alec Leamas
no flags Details | Diff

  None (edit)
Description Wolfgang Ulbrich 2013-09-09 05:19:40 EDT
Spec URL: http://raveit65.fedorapeople.org/Others/SPECS/faience-icon-theme.spec
SRPM URL: http://raveit65.fedorapeople.org/Others/SRPM/faience-icon-theme-0.5.1-2.fc21.src.rpm
Description: Faience icon theme
Fedora Account System Username: raveit65
Comment 1 Mohamed El Morabity 2013-09-09 07:13:52 EDT
Hi,

some comments:

- expurging nonfree media files from the tarball is OK, but you should anyway document the way you drop those files from the original upstream tarball, as recommended by the guidelines:
   http://fedoraproject.org/wiki/Packaging:SourceURL#When_Upstream_uses_Prohibited_Code
  I had the same issue with one of my packages (light-themes), you can have a look at the script I embedded in my src.rpm to generate a "clean" tarball from the original one:
   http://pkgs.fedoraproject.org/cgit/light-themes.git/tree/light-themes-generate-tarball.sh?h=f19
   By the way, using a script will make easier future major updates of your package.

- according to the index.theme files provided for each icon theme, Faience depends on Faenza, GNOME and hicolor themes for missing icons. As a result, you should add faenza-icon-theme and gnome-icon-theme as Requires (hicolor-icon-theme is already required by gnome-icon-theme).
Comment 2 Wolfgang Ulbrich 2013-09-09 07:31:58 EDT
(In reply to Mohamed El Morabity from comment #1)
> Hi,
> 
> some comments:
> 
> - expurging nonfree media files from the tarball is OK, but you should
> anyway document the way you drop those files from the original upstream
> tarball, as recommended by the guidelines:
Cool, will do.
>   
> http://fedoraproject.org/wiki/Packaging:
> SourceURL#When_Upstream_uses_Prohibited_Code
>   I had the same issue with one of my packages (light-themes), you can have
> a look at the script I embedded in my src.rpm to generate a "clean" tarball
> from the original one:
>   
> http://pkgs.fedoraproject.org/cgit/light-themes.git/tree/light-themes-
> generate-tarball.sh?h=f19
>    By the way, using a script will make easier future major updates of your
> package.
Thanks, i will try this to avoid this work again :)
> 
> - according to the index.theme files provided for each icon theme, Faience
> depends on Faenza, GNOME and hicolor themes for missing icons. As a result,
> you should add faenza-icon-theme and gnome-icon-theme as Requires
> (hicolor-icon-theme is already required by gnome-icon-theme).

I need to check this, but faenza-icon-theme is droped.
https://bugzilla.redhat.com/show_bug.cgi?id=1005176
For this reason i started this review, because i need faience or faenza for mate-themes-extras.
Comment 3 Wolfgang Ulbrich 2013-09-09 08:34:02 EDT
I'm pretty shure that the author use gnome-icon-theme because of symbolic icons for GTK3 application, adding g-i-t as runtime require seems OK for me.
I think i will remove faenza-icon-theme from faience index.theme file.
First test in MATE shows me that no icons are missing.
Maybe the author use faenza-icon-theme to avoid to add the tons of nonfree icons to his theme. :)
See what i did yesterday for mate-icon-theme-faenza :)
https://github.com/mate-desktop/mate-icon-theme-faenza/commit/c1478671383a3c7960714b31f2bdc480535e4f98
What do you think?
Comment 4 Wolfgang Ulbrich 2013-09-09 12:48:43 EDT
scratch build at koji.
http://koji.fedoraproject.org/koji/taskinfo?taskID=5914128

%changelog
* Mon Sep 09 2013 Wolfgang Ulbrich <chat-to-me@raveit.de> 0.5.2-1
- bump micro version to get higher version as external MATE repo for f18
- add script to generate a tarball without nonfree icons
- remove faenza-icon-theme require from index.theme

Spec URL: http://raveit65.fedorapeople.org/Others/SPECS/faience-icon-theme.spec
SRPM URL: http://raveit65.fedorapeople.org/Others/SRPM/faience-icon-theme-0.5.2-1.fc21.src.rpm
Comment 5 Alec Leamas 2013-09-10 09:02:03 EDT
I'll do this, probably tomorrow.
Comment 6 Mohamed El Morabity 2013-09-10 09:32:59 EDT
(In reply to Wolfgang Ulbrich from comment #4)
> scratch build at koji.
> http://koji.fedoraproject.org/koji/taskinfo?taskID=5914128
> 
> %changelog
> * Mon Sep 09 2013 Wolfgang Ulbrich <chat-to-me@raveit.de> 0.5.2-1
> - bump micro version to get higher version as external MATE repo for f18

Be careful, the version tag corresponds to the *upstream* version of the project you package. And nothing else!
On you own repository, faience-icon-theme is available in version 0.5.1. I can't find such a version on the Faience Google Code site; the latest seems to be 0.5. Which version of the Faience theme are you packaging exactly?
If the "real" upstream version is 0.5, please use it as Version tag in your .spec. As a result, to deal with upgrades from your own repository, you can use Epoch from a "bad-versionned" 0.5.1 package to a "good-versionned" 0.5:
https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#Epochs_from_Third_Party_Repositories
http://www.rpm.org/max-rpm-snapshot/s1-rpm-depend-manual-dependencies.html#S3-RPM-DEPEND-VERSION-NOT-ENOUGH
Comment 7 Wolfgang Ulbrich 2013-09-10 10:10:31 EDT
Thank you for the hint, i will add a epoch tag.
Comment 8 Alec Leamas 2013-09-10 10:42:56 EDT
Wait... is an epoch really the proper solution here? I don't really have the time right now, but at a first glimpse I hesitate... back tomorrow on this (and probably some more issues...)
Comment 9 Wolfgang Ulbrich 2013-09-10 11:15:17 EDT
I will wait, because only f18 is the prob for the release version.
Here i use faience-icon-theme-0.5.1-0101.f18 in my repo, for f19 i use faience-icon-theme-0.5.1-1.fc19.
But if i drop the micro version.....than it affected also f19, imo.
Maybe i should remove the package from the external repo and don't care about updating.
Comment 10 Alec Leamas 2013-09-10 12:08:52 EDT
OK, some preliminary remarks right away:

- The version: As Mohamed says, the upstream version is 0.5 -> Version: 0.5. Period.
- You have made changes in the upstream sources, some sort of patches. Isn't this actually a release? So, instead of using bad Version: 0.5.2 you could set Version: 0.5 and Release: 2%{?dist}?
- Related to this is that macros are sort of over-used. The %theme_name macro really doesn't add anything, just set Name: faience-icon-theme. Likewise, when you set the Version:0.5 you can git rid of the %theme_minor_version macro, and just use %{version} instead.
- If I understand this correct there has not been any faience-icon-theme package in Fedora previously, but in your external repo (?). To add an Epoch: just to fix the upgrades for people having used this repo seems like overkill to me. Can you use Conflict: or Obsoletes: with exact version match(es) to get around this problem? Or just let upgrades fail for those users? Basically, having an Epoch: in the fresh, reviewed package seems broken.
- The unpacking seems a bit risky, having the ||: suffix on the tar commands. Instead, use the %setup macro as intended with multiple sources, see e. g., [1].
- The package does not require anything from gnome (just /bin/sh), is this as intended?
- The comment on the script generating the source is misplaced right over Source0.
- Add time-stamp preserving flags (e. g., cp -a and install -p)  to all copy commands in %install.
- I note that the SUSE obs version [2] removes any icon-theme.cache files in %prep. Perhaps good to be safe when upgrading even if it's not really required as of now?


[1] http://www.rpm.org/max-rpm/s1-rpm-inside-macros.html
[2] http://rpm.pbone.net/index.php3/stat/3/srodzaj/2/search/faience-icon-theme-0.5-2.1.src.rpm
Comment 11 Alec Leamas 2013-09-10 12:36:29 EDT
Hm, the upgrades... My proposal: If you want to support users of the external repo, duplicate this package as e. g. 0.5.2 in the external repo. This way people using that repo will get their update. Next update is probably 0.6-1. When this is released, you just don't do anything in the external repo. This scheme will give clean upgrade paths for all users. If you just don't release anything more on the external repo, those users will not be automagically updated until the 0.6 release. This might or might not be a problem, but then easily fixed.
Comment 12 Wolfgang Ulbrich 2013-09-10 18:25:49 EDT
(In reply to Alec Leamas from comment #11)
> Hm, the upgrades... My proposal: If you want to support users of the
> external repo, duplicate this package as e. g. 0.5.2 in the external repo.
> This way people using that repo will get their update. Next update is
> probably 0.6-1. When this is released, you just don't do anything in the
> external repo. This scheme will give clean upgrade paths for all users. If
> you just don't release anything more on the external repo, those users will
> not be automagically updated until the 0.6 release. This might or might not
> be a problem, but then easily fixed.

Yeap, good idea .....will do that

(In reply to Alec Leamas from comment #10)
> OK, some preliminary remarks right away:
> 
> - The version: As Mohamed says, the upstream version is 0.5 -> Version: 0.5.
> Period.
> - You have made changes in the upstream sources, some sort of patches. Isn't
> this actually a release? So, instead of using bad Version: 0.5.2 you could
> set Version: 0.5 and Release: 2%{?dist}?
yes , i will change this.
> - Related to this is that macros are sort of over-used. The %theme_name
> macro really doesn't add anything, just set Name: faience-icon-theme.
> Likewise, when you set the Version:0.5 you can git rid of the
> %theme_minor_version macro, and just use %{version} instead.

agree, this version from orgiginal spec file is really over macro'ed

> - If I understand this correct there has not been any faience-icon-theme
> package in Fedora previously, but in your external repo (?). To add an
> Epoch: just to fix the upgrades for people having used this repo seems like
> overkill to me. Can you use Conflict: or Obsoletes: with exact version
> match(es) to get around this problem? Or just let upgrades fail for those
> users? Basically, having an Epoch: in the fresh, reviewed package seems
> broken.

agree

> - The unpacking seems a bit risky, having the ||: suffix on the tar
> commands. Instead, use the %setup macro as intended with multiple sources,
> see e. g., [1].

Maybe it's late, but i use %setup macro for unpacking the tarbal.
tar -zxvf ${theme}.tar.gz &>/dev/null ||:
is use for unpacking the tar.gz's inside the main tarbal.
Can you you give a example for better understanding?

> - The package does not require anything from gnome (just /bin/sh), is this
> as intended?
index.theme file contains 'Inherits=Faenza,gnome,hicolor'
I have remove faenza-icon theme in cleaned tarball and will add gnome-icon-theme as rumtime require for symbolic icons for GTK3 apps.

> - The comment on the script generating the source is misplaced right over
> Source0.
will do.

> - Add time-stamp preserving flags (e. g., cp -a and install -p)  to all copy
> commands in %install.
changing
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/icons
to
install -p -dm 755 $RPM_BUILD_ROOT%{_datadir}/icons
oK?

> - I note that the SUSE obs version [2] removes any icon-theme.cache files in
> %prep. Perhaps good to be safe when upgrading even if it's not really
> required as of now?
I will add
find -type f -name "icon-theme.cache" -delete -print

new spec file:  http://raveit65.fedorapeople.org/Others/SPECS/faience-icon-theme.spec

* Mon Sep 09 2013 Wolfgang Ulbrich <chat-to-me@raveit.de> 0.5-1
- fix version
- clean macros
- add gnome-icon-theme as runtime require
- Add time-stamp preserving flags
- remove icon-cache's from source
Comment 13 Alec Leamas 2013-09-11 02:05:20 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Blockers:
- Fix typos so that spec actually builds.
- Drop the '|| :' from the tar commands in %setup. If these fail, the
  build should fail.
- The description should expand on the summary, but doesn't. At a minimum,
  list the different themes here. You should also mention that some
  icons are not packaged.

Other issues:
- The %install section looks a little clumsy. By using 'cp -r %themes
  $RPM_BUILD_ROOT%{_datadir}/icons" you should be able to avoid the
  rm -f  $RPM_BUILD_ROOT%{_datadir}/icons/*.gz stuff.
- There is some trailing whitespace in the spec making maintenance
  harder.
- Use two blank lines between each section to improve readability.
- Flush the changelog before importing into git. The previous history
  is of no interest, and the versions does not upgrade properly.

Attaching patches for most issues (since I had to fix it to make it build anyway).


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 4 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[-]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[!]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: faience-icon-theme-0.5.2-1.fc21.noarch.rpm
          faience-icon-theme-0.5.2-1.fc21.src.rpm
faience-icon-theme.src: W: strange-permission faience-icon-theme-generate-tarball.sh 0775L
2 packages and 0 specfiles checked; 0 errors, 1 warnings.
---> As expected, no problem.


Rpmlint (installed packages)
----------------------------
# rpmlint faience-icon-theme
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
faience-icon-theme (rpmlib, GLIBC filtered):
    /bin/sh


Provides
--------
faience-icon-theme:
    faience-icon-theme


Source checksums
----------------
http://raveit65.fedorapeople.org/Others/Source/faience-icon-theme_0.5.tar.xz :
  CHECKSUM(SHA256) this package     : da76bdbd52b6a542d823337aa3661a19d98ee7e56332dbef167c9be2aed36f54
  CHECKSUM(SHA256) upstream package : da76bdbd52b6a542d823337aa3661a19d98ee7e56332dbef167c9be2aed36f54


Generated by fedora-review 0.5.0 (cf3fdcf) last change: 2013-09-06
Command line :./try-fedora-review -b 1005718
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Comment 14 Alec Leamas 2013-09-11 02:06:55 EDT
Created attachment 796258 [details]
Fix whitespace
Comment 15 Alec Leamas 2013-09-11 02:07:33 EDT
Created attachment 796259 [details]
remove ||:
Comment 16 Alec Leamas 2013-09-11 02:08:10 EDT
Created attachment 796260 [details]
fix install options
Comment 17 Alec Leamas 2013-09-11 02:09:20 EDT
Created attachment 796261 [details]
%install fixes: bad macro, bad options, cleanup
Comment 18 Alec Leamas 2013-09-11 02:09:59 EDT
Created attachment 796262 [details]
Formatting
Comment 20 Alec Leamas 2013-09-11 04:47:38 EDT
All looks good. 

*** APPROVED

BTW: I obviously did not push the reply button yesterday. I was plain wrong when talking about using %setup on the tarballs. Sorry for that.
Comment 21 Wolfgang Ulbrich 2013-09-11 05:37:24 EDT
Thank you for the review Alec.

New Package SCM Request
=======================
Package Name: faience-icon-theme
Short Description: Faience icon theme
Owners: raveit65
Branches: f18 f19 f20
InitialCC:
Comment 22 Gwyn Ciesla 2013-09-11 08:08:37 EDT
Git done (by process-git-requests).
Comment 23 Fedora Update System 2013-09-11 10:55:37 EDT
faience-icon-theme-0.5-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/faience-icon-theme-0.5-1.fc19
Comment 24 Fedora Update System 2013-09-11 10:55:47 EDT
faience-icon-theme-0.5-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/faience-icon-theme-0.5-1.fc20
Comment 25 Fedora Update System 2013-09-11 10:56:01 EDT
faience-icon-theme-0.5-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/faience-icon-theme-0.5-1.fc18
Comment 26 Fedora Update System 2013-09-11 13:00:37 EDT
faience-icon-theme-0.5-1.fc20 has been pushed to the Fedora 20 testing repository.
Comment 27 Fedora Update System 2013-09-20 12:20:47 EDT
faience-icon-theme-0.5-1.fc18 has been pushed to the Fedora 18 stable repository.
Comment 28 Fedora Update System 2013-09-20 12:24:12 EDT
faience-icon-theme-0.5-1.fc19 has been pushed to the Fedora 19 stable repository.
Comment 29 Fedora Update System 2013-09-22 20:24:08 EDT
faience-icon-theme-0.5-1.fc20 has been pushed to the Fedora 20 stable repository.
Comment 30 Wolfgang Ulbrich 2014-11-14 16:18:29 EST
Package Change Request
======================
Package Name: faience-icon-theme
New Branches: epel7
Owners: raveit65
Comment 31 Gwyn Ciesla 2014-11-17 08:07:01 EST
Git done (by process-git-requests).
Comment 32 Fedora Update System 2014-11-17 08:29:32 EST
faience-icon-theme-0.5-3.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/faience-icon-theme-0.5-3.el7
Comment 33 Fedora Update System 2014-11-18 03:11:18 EST
Package faience-icon-theme-0.5-3.el7:
* should fix your issue,
* was pushed to the Fedora EPEL 7 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing faience-icon-theme-0.5-3.el7'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2014-4121/faience-icon-theme-0.5-3.el7
then log in and leave karma (feedback).
Comment 34 Fedora Update System 2014-12-03 01:37:03 EST
faience-icon-theme-0.5-3.el7 has been pushed to the Fedora EPEL 7 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.